
% ------------------------------------------------------------------------------
% Control Automatic I - Practica 2 Part II
% Representacio de grafiques per a la resposta temporal a esglao, modul de
% la resposta frequencial, fase de la resposta frequencial i mapa de pols
% i zeros. Es predefineix una funcio de transferencia i es demanen a l'usuari
% valors concrets per a la frequencia natural i el coeficient d'esmorteiment.
% Realtizat per: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma
% ------------------------------------------------------------------------------

disp(' ------------------------------------------------------------------------------------');
disp('  Representacio grafica de respostes temporal i frequencial, i mapa de pols i zeros.');
disp(' ------------------------------------------------------------------------------------');
wn = input(' \n Introdueix el valor de la frequencia natural: ');
zeta = input(' Introdueix el valor del coeficient desmorteiment: ');
t = 0:15/200:(15-15/200); 	             % Vector temps
w = logspace(-1,1,200);  		         % Vector de frequencies
num = wn^2; 				             % Numerador de la funcio de transferencia
den = [1 2*zeta*wn wn^2];            	 % Denominador de la funcio de transferencia
y = step(num,den,t);	  	             % Resposta a l'esglao
[mag fas] = bode(num,den,w);	         % Resposta freqencial

% Grafica de la resposta temporal a un esglao
figure(1)
plot(t,y); 
xlabel('t'); 
ylabel('y(t)');
title('Resposta Temporal a un Esglao');

% Grfica del mdul en dB de la resposta freqencial
figure(2)
semilogx(w,20*log10(mag));
xlabel('w');
ylabel('dB');
title('Modul de la Resposta Frequencial');

% Grfica de la fase de la resposta freqencial
figure(3);
semilogx(w,fas); 
xlabel('w');
ylabel('graus');
title('Fase de la Resposta Frequencial');

% Diagrama de pols i zeros
figure(4);
pzmap(num,den);
title('Mapa de Pols i Zeros');
