
% ------------------------------------------------------------------------------
% Control Automatic I - Practica 2 Part II
% Funcio que calcula el Pic i l'Ample de Banda del vector modul de la resposta
% frequencial per a una certa funcio de transferencia. Es podra especificar
% si el vector modul esta o no expressat en DBs. Retorna les posicions del
% vector modul on es troben el minim i maxim de l'ample de banda i el pic;
% i retorna tambe el tipus de sistema tractat (passa baixes, passa altes, etc).
% [minim_BW,maxim_BW,index_pic,tipus_BW] = parbode(modul,mesura_DB)
% Realtizat per: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma
% ------------------------------------------------------------------------------

function [minim_BW,maxim_BW,index_pic,tipus_BW] = parbode(modul,w,mesura_DB)

comptador = 1;
valor_maxim = modul(1);
while comptador <= length(modul)
   if modul(comptador) >= valor_maxim
      valor_maxim = modul(comptador);
      index_pic = comptador;
   end
   comptador = comptador + 1;
end
if mesura_DB == 1
   llindar_BW = valor_maxim - 3;    
else
   llindar_BW = valor_maxim * (1/sqrt(2));
end
if index_pic == 1
    % Sistema "Passa Baixes"
    maxim_BW = 1;
    i = 1;
    while modul(i) > llindar_BW
       i = i + 1;
    end
    minim_BW = i;
    tipus_BW = 'Passa Baixes';
    
elseif index_pic >= length(modul)    
    % Sistema "Passa Altes"
    maxim_BW = index_pic; 
    i = 1;
    while modul(i) < llindar_BW
       i = i + 1;
    end
    minim_BW = i;
    tipus_BW = 'Passa Altes';    
else
    % Sistema "Passa Bandes"
    i = index_pic;
    while (i > 0) & (modul(i) > llindar_BW)
       i = i - 1;
    end
    if (i == 0)
        minim_BW = 1;
    else
        minim_BW = i;
    end
    i = index_pic;
    while (i <= length(modul)) & (modul(i) > llindar_BW)
       i = i + 1;
    end
    maxim_BW = i;
    if i > length(modul)
        maxim_BW = length(modul);
    end
    tipus_BW = 'Passa Bandes';
end
if w(maxim_BW) < w(minim_BW)
   aux = maxim_BW;
   maxim_BW = minim_BW;
   minim_BW = aux;
end

