
function [Sp,Tr,Ts]=parstep(y,t,yss)
%Calcula diferents parmetres de la resposta a l'esgla
%y resposta temporal
%t vector de temps
%yss resposta en estat estacionari

%Sobreimpuls (en %)
Sp=100*(max(y)-yss)/yss;

% Temps de pujada
n=1;
while y(n)<yss
	n=n+1;
end;
Tr=t(n);

%Temps d'establiment (2 %)
for n=1:length(y)
	if(y(n)<0.98*yss) | (y(n)>1.02*yss)
		Ts=t(n);
	end
end %end programa

